AnimalsManager = {};

AnimalsManager.metadata = {
	interface = " FS19 1.x",
	title = " AnimalsManager",
	notes = " Ändert/Setzt/Aktiviert Animals Values",
	author = " (by HappyLooser)",
	version = " v0.5 Beta",
	datum = " 24.12.2018",
	update = " 10.03.2019",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

--0.5
--update liter/dezimal 1.000 ---> 1000
--fix animalCleanLinessOff string
--new visualHorseHud + extras(prio high,VehicleFruitHud prio low),optional deactivate Care,optional deactivate Riding, mp horse limit default small 8 and large 16(sp over xml edit optional)
AnimalsManager.modDir = g_currentModDirectory;
function AnimalsManager:loadMap(name)
	g_currentMission.animalsManager = AnimalsManager;	
	print("---loading".. tostring(AnimalsManager.metadata.title).. tostring(AnimalsManager.metadata.version).. tostring(AnimalsManager.metadata.author).. "---")
	--if isServer() then return;end;
	if not isServer() then source(AnimalsManager.modDir.."AnimalsManagerVisualHud.lua");end;
	AnimalsManager.settingsDir = getUserProfileAppPath().. "modsSettings/AnimalsManager/";	
	AnimalsManager.mpHostServer = {animalPlaceableLimit=20, animalVisualLimit=10, animalCleanLinessOff="", animalCleanLinessOn=false, horseDeactivateRiding=false, horseDeactivateCare=false};	
	AnimalsManager.singlePlayer = {horseBarnPlusLimit=4, animalPlaceableLimit=30, animalVisualLimit=10, animalCleanLinessOff="", animalCleanLinessOn=false, horseDeactivateRiding=false, horseDeactivateCare=false};
	AnimalsManager.mpDetiServer = {animalPlaceableLimit=100, animalVisualLimit=10, animalCleanLinessOff="", animalCleanLinessOn=false, horseDeactivateRiding=false, horseDeactivateCare=false};	
	AnimalsManager.visualDisplay = {on=true, index=nil};	
	AnimalsManager.visualHorseRidingHud = true;
	AnimalsManager.visualHorseRidingHudTemp = true;
	AnimalsManager.horseValues = {dayRiding=true, care=true}; --Global for VehicleFruitHorseHud
	AnimalsManager.hlDebugMode = false;
	--AnimalsManager.updateVisual = false;
	AnimalsManager.indexToAnimals = {};
	AnimalsManager.indexToAnimalsModule = {};
	AnimalsManager.indexToHorseRiding = {};
	AnimalsManager.isServerUpdate = false;
	AnimalsManager:setGetCfg(true);
	AnimalsManager.horseValues.dayRiding = not AnimalsManager.singlePlayer.horseDeactivateRiding;
	AnimalsManager.horseValues.care = not AnimalsManager.singlePlayer.horseDeactivateCare;
	AnimalsManager.visualHorseRidingHudTemp = AnimalsManager.visualHorseRidingHud;
	if AnimalsManager:isHostMp() then
		AnimalsManager.mpDetiServer.animalCleanLinessOff = AnimalsManager.mpHostServer.animalCleanLinessOff;
		AnimalsManager.mpDetiServer.animalVisualLimit = AnimalsManager.mpHostServer.animalVisualLimit;
		AnimalsManager.mpDetiServer.animalPlaceableLimit = AnimalsManager.mpHostServer.animalPlaceableLimit;
		AnimalsManager.mpDetiServer.animalCleanLinessOn = AnimalsManager.mpHostServer.animalCleanLinessOn;
		AnimalsManager.mpDetiServer.horseDeactivateRiding = AnimalsManager.mpHostServer.horseDeactivateRiding;
		AnimalsManager.horseValues.dayRiding = not AnimalsManager.mpHostServer.horseDeactivateRiding;
		AnimalsManager.mpDetiServer.horseDeactivateCare = AnimalsManager.mpHostServer.horseDeactivateCare;
		AnimalsManager.horseValues.care = not AnimalsManager.mpHostServer.horseDeactivateCare;
	end;
	if isServer() then AnimalsManager.horseValues.dayRiding = not AnimalsManager.mpDetiServer.horseDeactivateRiding;AnimalsManager.horseValues.care = not AnimalsManager.mpDetiServer.horseDeactivateCare;end;
	AnimalsManager.isLoadMap = false;
	AnimalsManager:init();
	if not isServer() then AnimalsManagerVisualHud:loadHud();end;
end;

function AnimalsManager:deleteMap()
	if isServer() then return;end;
	AnimalsManager:setGetCfg(false);	
end;

function AnimalsManager:mouseEvent(posX, posY, isDown, isUp, button)
end;

function AnimalsManager:keyEvent(unicode, sym, modifier, isDown)
	--if isServer() then return;end;	
end;

function AnimalsManager:update(dt)	
	if isServer() then return;end;	
	if not AnimalsManager.isLoadMap and not isServer() and not AnimalsManager:isHostMp() and AnimalsManager:isMp() then AnimalsManagerEvent.sendEvent("", true);
	elseif not AnimalsManager.isLoadMap and not AnimalsManager:isMp() then AnimalsManager:setCleanLiness();AnimalsManager:setVisual();end; --AnimalsManager:deactivateRiding();AnimalsManager:deactivateCare();end;
	if not AnimalsManager.isLoadMap then AnimalsManager.isLoadMap = true;end;
end;

function AnimalsManager:draw(dt)
	if isServer() then return;end;
	if AnimalsManager.visualDisplay.on then AnimalsManagerVisualHud:update();end;
	if AnimalsManager.visualHorseRidingHudTemp then AnimalsManagerVisualHud:drawHorseHud();end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;

function AnimalsManager:init()
	AnimalsManager:setGetCfg(false)
	source(AnimalsManager.modDir.."_hl.lua");	
end;
addModEventListener(AnimalsManager);

function isServer()
	return g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil;
end;

function AnimalsManager:isMp()
	return g_currentMission.missionDynamicInfo.isMultiplayer;	
end;

function AnimalsManager:isHostMp()
	return AnimalsManager:isMp() and g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo == nil;
end;

function AnimalsManager:deactivateRiding(animals)
	function setDeactivateRiding(animal)
		if animal == nil then print("not found animal");table.remove(AnimalsManager.indexToHorseRiding, animal);return;end;
		if isServer() or AnimalsManager:isMp() then 
			if AnimalsManager.mpDetiServer.horseDeactivateRiding then
				animal.ridingTimer = Horse.DAILY_TARGET_RIDING_TIME;
				animal.ridingTimerSent = animal.ridingTimer;
				animal.ridingScale = 1.0;
				animal.ridingScaleSent = animal.ridingScale;				
			end;
		elseif not AnimalsManager:isMp() then			
			if AnimalsManager.singlePlayer.horseDeactivateRiding then				
				animal.ridingTimer = Horse.DAILY_TARGET_RIDING_TIME;
				animal.ridingTimerSent = animal.ridingTimer;
				animal.ridingScale = 1.0;
				animal.ridingScaleSent = animal.ridingScale;				
			end;
		end;
	end;
	if animals ~= nil then
		setDeactivateRiding(animals);
	elseif AnimalsManager.indexToHorseRiding ~= nil then
		for key, animalObject in pairs(AnimalsManager.indexToHorseRiding) do			
			if animalObject ~= nil then	setDeactivateRiding(animalObject);end;
		end;
	end;
end;

--local oldHorse = Horse.new
--Horse.new = function(...)
--	local isOkay, result = pcall(oldHorse, ...);
--	if isOkay and result ~= nil then		
--		table.insert(AnimalsManager.indexToHorseRiding, result);		
--		if AnimalsManager.isLoadMap then			
--			AnimalsManager:deactivateRiding(result);
--		end;
--		return result;
--	end;
--	return false;
--end;

--local oldHorseRidingUpdate = Horse.updateFitness
--Horse.updateFitness = function(...)
--	local isOkay, result = pcall(oldHorseRidingUpdate, ...);
--	if isOkay then
--		if AnimalsManager.isLoadMap then			
--			AnimalsManager:deactivateRiding();			
--		end;
--	end;
--end;

function AnimalsManager:deactivateCare(animals)
	function setDeactivateCare(animal)
		if animal == nil then print("not found animal");table.remove(AnimalsManager.indexToHorseRiding, animal);return;end;
		if isServer() or AnimalsManager:isMp() then 
			if AnimalsManager.mpDetiServer.horseDeactivateCare then
				animal.dirtScale = 0.0;
				animal.dirtScaleSent = animal.dirtScale;				
			end;
		elseif not AnimalsManager:isMp() then			
			if AnimalsManager.singlePlayer.horseDeactivateCare then
				animal.dirtScale = 0.0;
				animal.dirtScaleSent = animal.dirtScale;				
			end;
		end;
	end;
	if animals ~= nil then
		setDeactivateCare(animals);
	elseif AnimalsManager.indexToHorseRiding ~= nil then
		for key, animalObject in pairs(AnimalsManager.indexToHorseRiding) do			
			if animalObject ~= nil then	setDeactivateCare(animalObject);end;
		end;
	end;
end;

--local oldHorseOnFitnessChangedCallback = Horse.onFitnessChangedCallback
--Horse.onFitnessChangedCallback = function(...)
--	local isOkay, result = pcall(oldHorseOnFitnessChangedCallback, ...);
--	if isOkay then
--		if AnimalsManager.isLoadMap then
--			AnimalsManager:deactivateRiding();
--			AnimalsManager:deactivateCare();
--		end;
--	end;
--end;

--local oldRideableAnimalOnLoadedRideable = RideableAnimal.onLoadedRideable
--RideableAnimal.onLoadedRideable = function(self, rideableVehicle, vehicleLoadState, arguments)
--	local isOkay, result = pcall(oldRideableAnimalOnLoadedRideable, self, rideableVehicle, vehicleLoadState, arguments);
--	if isOkay and rideableVehicle ~= nil then
--		if AnimalsManager.isLoadMap then			
--			AnimalsManager:deactivateRiding();
--			AnimalsManager:deactivateCare();
--		end;
--	end;	
--end;

--local oldRideableAnimalDirtScale = RideableAnimal.onDirtChangedCallback
--RideableAnimal.onDirtChangedCallback = function(...)
--	local isOkay, result = pcall(oldRideableAnimalDirtScale, ...);
--	if isOkay then
--		if AnimalsManager.isLoadMap then
--			AnimalsManager:deactivateCare();
--		end;
--	end;
--end;

local oldHusbandryModuleAnimalDelete = HusbandryModuleAnimal.delete
HusbandryModuleAnimal.delete = function(self)
	local isOkay, result = pcall(oldHusbandryModuleAnimalDelete, self);
	if isOkay and self ~= nil then
		for key, animalObject in pairs(AnimalsManager.indexToAnimalsModule) do			
			if animalObject ~= nil and animalObject == self then table.remove(AnimalsManager.indexToAnimalsModule, key);break;end;
		end;
	end;
end;

local oldAnimalHusbandryUnregister = AnimalHusbandry.unregisterHusbandryToMission
AnimalHusbandry.unregisterHusbandryToMission = function (self)
	local isOkay, result = pcall(oldAnimalHusbandryUnregister, self);
	if isOkay and self ~= nil then
		for key, animalObject in pairs(AnimalsManager.indexToAnimals) do			
			if animalObject ~= nil and animalObject == self then table.remove(AnimalsManager.indexToAnimals, key);break;end;
		end;
		return result;
	end;
	return false;
end;

function AnimalsManager:setVisual(animals)	
	function setVisual(animal)
		if animal.animalType == "HORSE" then if not AnimalsManager:isMp() and AnimalsManager.singlePlayer.horseBarnPlusLimit > 0 then animal:updateVisualAnimals();end;return;end; --savegame SP update
		if isServer() or AnimalsManager:isMp() then
			local updateVisual = animal.maxNumVisualAnimals > AnimalsManager.mpDetiServer.animalVisualLimit;		
			animal.maxNumVisualAnimals=AnimalsManager.mpDetiServer.animalVisualLimit;
			if updateVisual then animal:updateVisualAnimals();end;			
		elseif not AnimalsManager:isMp() then 
			local updateVisual = animal.maxNumVisualAnimals > AnimalsManager.singlePlayer.animalVisualLimit;			
			animal.maxNumVisualAnimals=AnimalsManager.singlePlayer.animalVisualLimit;
			if updateVisual then animal:updateVisualAnimals();end;
		end;
	end;	
	if animals ~= nil then
		setVisual(animals);		
	elseif AnimalsManager.indexToAnimalsModule ~= nil then
		for key, animalObject in pairs(AnimalsManager.indexToAnimalsModule) do			
			if animalObject ~= nil then	setVisual(animalObject);end;
		end;
	end;	
end;

local oldHusbandryModuleAnimal = HusbandryModuleAnimal.load; 
HusbandryModuleAnimal.load = function(self, xmlFile, configKey, rootNode, owner)
	local isOkay, result = pcall(oldHusbandryModuleAnimal, self, xmlFile, configKey, rootNode, owner);	
	if isOkay then
		if self ~= nil and self.animalType ~= "DOG" then 
			table.insert(AnimalsManager.indexToAnimalsModule, self);
			if AnimalsManager.isLoadMap then				
				AnimalsManager:setVisual(self);
			end;
			--for key, value in pairs(self) do					
			--	print(" 1 key und value ...".. tostring(key).. "-----".. tostring(value))
			--	if type(value) == "table" then
			--		for key1, value1 in pairs(value) do
			--			print(" 2 key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
			--			if type(value1) == "table" then
			--				for key2, value2 in pairs(value1) do
			--					print(" 3 key2 und value2 ...".. tostring(key2).. "-----".. tostring(value2))
			--				end;
			--			end;
			--		end;
			--	end;
			--end;
		end;		
		return result;	
	end;
	return false;	
end;

function AnimalsManager:setCleanLiness(animals)		
	function setCleanLiness(animal)
		--AnimalsManagerVisualHud:createHud(animal);		
		local foodSpillageModule = animal:getModuleByName("foodSpillage");
		local animalsModule = animal:getModuleByName("animals");
		if animalsModule1 ~= nil and animalsModule.animalType == "HORSE" then return;end;
		if foodSpillageModule ~= nil and animalsModule ~= nil then
			local animalName = tostring(animalsModule:getAnimalType():lower());
			local isCleanLiness = nil;
			if isServer() or (AnimalsManager:isMp()) and string.len(AnimalsManager.mpDetiServer.animalCleanLinessOff) > 0 then isCleanLiness = string.find(AnimalsManager.mpDetiServer.animalCleanLinessOff, animalName);elseif not AnimalsManager:isMp() and string.len(AnimalsManager.singlePlayer.animalCleanLinessOff) > 0 then isCleanLiness = string.find(AnimalsManager.singlePlayer.animalCleanLinessOff, animalName);end;
			if foodSpillageModule.hasCleanliness ~= nil and foodSpillageModule.hasCleanliness and isCleanLiness ~= nil and isCleanLiness then 
				foodSpillageModule.hasCleanliness = false;foodSpillageModule.cleanlinessFactor=1.000000;foodSpillageModule.foodToDrop=0.000000;
			elseif foodSpillageModule.hasCleanliness ~= nil and not foodSpillageModule.hasCleanliness and isCleanLiness ~= nil and not isCleanLiness then
				if (isServer() or (AnimalsManager:isMp()) and AnimalsManager.mpDetiServer.animalCleanLinessOn) or (not AnimalsManager:isMp() and AnimalsManager.singlePlayer.animalCleanLinessOn) then 
					foodSpillageModule.hasCleanliness = true;
				end;
			end;			
		end;
	end;	
	if animals ~= nil then
		setCleanLiness(animals);
	elseif AnimalsManager.indexToAnimals ~= nil then 
		for key, animalObject in pairs(AnimalsManager.indexToAnimals) do			
			if animalObject ~= nil then	setCleanLiness(animalObject);end;
		end;
	end;	
end;


local oldAnimalHusbandry = AnimalHusbandry.load; 
AnimalHusbandry.load = function(self, xmlFilename, x, y, z, rx, ry, rz, initRandom)	
	if AnimalsManager.isMp then AnimalHusbandry.GAME_LIMIT = AnimalsManager.mpDetiServer.animalPlaceableLimit;else AnimalHusbandry.GAME_LIMIT = AnimalsManager.singlePlayer.animalPlaceableLimit;end;
	local isOkay, result = pcall(oldAnimalHusbandry, self, xmlFilename, x, y, z, rx, ry, rz, initRandom);
	if isOkay and self ~= nil and self.nodeId ~= nil and self.nodeId > 0 then
		table.insert(AnimalsManager.indexToAnimals, self);			
		local animalsModule = self:getModuleByName("animals");
		if animalsModule ~= nil and animalsModule.animalType == "HORSE" and not AnimalsManager:isMp() then --only SP (mp is error,check later)
			local limit = AnimalsManager.singlePlayer.horseBarnPlusLimit;
			if limit > 0 then
				--if isServer() or AnimalsManager:isMp() then limit = 4;end;
				animalsModule.maxNumVisualAnimals = animalsModule.maxNumVisualAnimals+limit;
				animalsModule.maxNumAnimals = animalsModule.maxNumAnimals+limit;
				animalsModule:updateVisualAnimals();
			end;
		end;
		if AnimalsManager.isLoadMap then
			AnimalsManager:setCleanLiness(self);			
		end;		
		return result;
	end;
	return false;
end;

function AnimalsManager:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if AnimalsManager.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if AnimalsManager.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if AnimalsManager.hlDebugMode and (not isOkay or foundArgsError) then AnimalsManager:setDebug("AnimalsManagerMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function AnimalsManager:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function AnimalsManager:setGetCfg(loadCfg)
	if not isServer() then
		createFolder(getUserProfileAppPath().. "modsSettings/");
		createFolder(AnimalsManager.settingsDir);
	end;
	local file = AnimalsManager.settingsDir.. "animalsManagerSettings.xml";
	if isServer() then file = getUserProfileAppPath().. "animalsManagerSettings.xml";end;
	local Xml = nil;
	local xmlVersion = 0.1;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("AnimalsManager_XML", file, "animalsManagerSettings");		
		local groupNameTag = ("AnimalsManagerSettings.version(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#xmlVersion", tostring(xmlVersion));
		groupNameTag = ("AnimalsManagerSettings.global(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#hlDebugMode", AnimalsManager.hlDebugMode);

		groupNameTag = ("AnimalsManagerSettings.global.visualDisplay.on(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.visualDisplay.on);
		groupNameTag = ("AnimalsManagerSettings.global.visualDisplay.horseRidingHud(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.visualHorseRidingHud);
		
		groupNameTag = ("AnimalsManagerSettings.acceptsAnimalCleanLinessOff(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#info", "pig sheep cow chicken horse or animal mods(register animal name)");		
		
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalPlaceableLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.singlePlayer.animalPlaceableLimit);
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalVisualLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.singlePlayer.animalVisualLimit);
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOff(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.singlePlayer.animalCleanLinessOff);
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOn(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.singlePlayer.animalCleanLinessOn);
		--groupNameTag = ("AnimalsManagerSettings.singlePlayer.horseDeactivateRiding(%d)"):format(0);		
		--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.singlePlayer.horseDeactivateRiding);
		--groupNameTag = ("AnimalsManagerSettings.singlePlayer.horseDeactivateCare(%d)"):format(0);		
		--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.singlePlayer.horseDeactivateCare);
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.horseBarnPlusLimit(%d)"):format(0);		
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.singlePlayer.horseBarnPlusLimit);
		
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalPlaceableLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpHostServer.animalPlaceableLimit);
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalVisualLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpHostServer.animalVisualLimit);
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOff(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.mpHostServer.animalCleanLinessOff);
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOn(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpHostServer.animalCleanLinessOn);
		--groupNameTag = ("AnimalsManagerSettings.mpHostServer.horseDeactivateRiding(%d)"):format(0);		
		--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpHostServer.horseDeactivateRiding);
		--groupNameTag = ("AnimalsManagerSettings.mpHostServer.horseDeactivateCare(%d)"):format(0);		
		--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpHostServer.horseDeactivateCare);
		
		if isServer() and fileExists(file) then
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalPlaceableLimit(%d)"):format(0);
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalPlaceableLimit);
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalVisualLimit(%d)"):format(0);
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalVisualLimit);
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOff(%d)"):format(0);
			setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.mpDetiServer.animalCleanLinessOff);
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOn(%d)"):format(0);		
			setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.animalCleanLinessOn);
			--groupNameTag = ("AnimalsManagerSettings.mpDetiServer.horseDeactivateRiding(%d)"):format(0);		
			--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.horseDeactivateRiding);
			--groupNameTag = ("AnimalsManagerSettings.mpDetiServer.horseDeactivateCare(%d)"):format(0);		
			--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.horseDeactivateCare);
		end;
		if isServer() and not fileExists(file) then
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalPlaceableLimit(%d)"):format(0);
			AnimalsManager.mpDetiServer.animalPlaceableLimit = 25;
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalPlaceableLimit);
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalVisualLimit(%d)"):format(0);
			AnimalsManager.mpDetiServer.animalVisualLimit = 10;
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalVisualLimit);
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOff(%d)"):format(0);
			AnimalsManager.mpDetiServer.animalCleanLinessOff = "";
			setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.mpDetiServer.animalCleanLinessOff);
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOn(%d)"):format(0);		
			AnimalsManager.mpDetiServer.animalCleanLinessOn = false;
			setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.animalCleanLinessOn);
			--groupNameTag = ("AnimalsManagerSettings.mpDetiServer.horseDeactivateRiding(%d)"):format(0);		
			AnimalsManager.mpDetiServer.horseDeactivateRiding = false;
			--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.horseDeactivateRiding);
			--groupNameTag = ("AnimalsManagerSettings.mpDetiServer.horseDeactivateCare(%d)"):format(0);
			AnimalsManager.mpDetiServer.horseDeactivateCare = false;
			--setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.horseDeactivateCare);
			
		end;
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("AnimalsManager_XML", file, "animalsManagerSettings");
		local groupNameTag = ("animalsManagerSettings.version(%d)"):format(0);
		if not getXMLString(Xml, groupNameTag.. "#xmlVersion") then AnimalsManager:saveOldXml();AnimalsManager:setGetCfg(false)return;end;
		local xmlVersionTemp = string.format("%1.1f", "".. getXMLString(Xml, groupNameTag.. "#xmlVersion"));		
		if tonumber(xmlVersionTemp) < tonumber(xmlVersion) then AnimalsManager:saveOldXml();AnimalsManager:setGetCfg(false)return;end;
		groupNameTag = ("AnimalsManagerSettings.global(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then AnimalsManager.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
		
		groupNameTag = ("AnimalsManagerSettings.global.visualDisplay.on(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.visualDisplay.on = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("AnimalsManagerSettings.global.visualDisplay.horseRidingHud(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.visualHorseRidingHud = getXMLBool(Xml, groupNameTag.. "#boolean");end;
								
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalPlaceableLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.singlePlayer.animalPlaceableLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalVisualLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.singlePlayer.animalVisualLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOff(%d)"):format(0);		
		if getXMLString(Xml, groupNameTag.. "#string") then AnimalsManager.singlePlayer.animalCleanLinessOff = getXMLString(Xml, groupNameTag.. "#string"):lower();end;
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOn(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.singlePlayer.animalCleanLinessOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		--groupNameTag = ("AnimalsManagerSettings.singlePlayer.horseDeactivateRiding(%d)"):format(0);		
		--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.singlePlayer.horseDeactivateRiding = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		--groupNameTag = ("AnimalsManagerSettings.singlePlayer.horseDeactivateCare(%d)"):format(0);		
		--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.singlePlayer.horseDeactivateCare = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("AnimalsManagerSettings.singlePlayer.horseBarnPlusLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.singlePlayer.horseBarnPlusLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		if AnimalsManager.singlePlayer.horseBarnPlusLimit < 0 then AnimalsManager.singlePlayer.horseBarnPlusLimit = 0;end;
				
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalPlaceableLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpHostServer.animalPlaceableLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalVisualLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpHostServer.animalVisualLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOff(%d)"):format(0);		
		if getXMLString(Xml, groupNameTag.. "#string") then AnimalsManager.mpHostServer.animalCleanLinessOff = getXMLString(Xml, groupNameTag.. "#string"):lower();end;
		groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOn(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpHostServer.animalCleanLinessOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		--groupNameTag = ("AnimalsManagerSettings.mpHostServer.horseDeactivateRiding(%d)"):format(0);		
		--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpHostServer.horseDeactivateRiding = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		--groupNameTag = ("AnimalsManagerSettings.mpHostServer.horseDeactivateCare(%d)"):format(0);		
		--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpHostServer.horseDeactivateCare = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		
		if isServer() then
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalPlaceableLimit(%d)"):format(0);		
			if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpDetiServer.animalPlaceableLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
			if AnimalsManager.mpDetiServer.animalPlaceableLimit > 100 then AnimalsManager.mpDetiServer.animalPlaceableLimit = 100;end;
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalVisualLimit(%d)"):format(0);		
			if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpDetiServer.animalVisualLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOff(%d)"):format(0);		
			if getXMLString(Xml, groupNameTag.. "#string") then AnimalsManager.mpDetiServer.animalCleanLinessOff = getXMLString(Xml, groupNameTag.. "#string"):lower();end;
			groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOn(%d)"):format(0);		
			if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpDetiServer.animalCleanLinessOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
			--groupNameTag = ("AnimalsManagerSettings.mpDetiServer.horseDeactivateRiding(%d)"):format(0);		
			--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpDetiServer.horseDeactivateRiding = getXMLBool(Xml, groupNameTag.. "#boolean");end;
			--groupNameTag = ("AnimalsManagerSettings.mpDetiServer.horseDeactivateCare(%d)"):format(0);		
			--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpDetiServer.horseDeactivateCare = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		end;
	end;	
end;

function AnimalsManager:saveOldXml()	
	if isServer() then return;end;
	local getDateString = tostring(getDate("%d").. "_".. getDate("%w").. "_".. getDate("%m").. "_".. getDate("%Y"));
	local oldXml = AnimalsManager.settingsDir.. "animalsManagerSettings.xml";	
	local backupXml = AnimalsManager.settingsDir.. "animalsManagerSettings_Old_Backup_".. getDateString.. ".xml";	
	copyFile(oldXml, backupXml, false);
end;	