AnimalsManagerEvent = {};
AnimalsManagerEvent_mt = Class(AnimalsManagerEvent, Event);
InitEventClass(AnimalsManagerEvent, "AnimalsManagerEvent");

function AnimalsManagerEvent:emptyNew()
	local self = Event:new(AnimalsManagerEvent_mt);
	self.className="AnimalsManagerEvent";
	return self;
end;

function AnimalsManagerEvent:new(animalsTable, noEventSend)
	local self = AnimalsManagerEvent:emptyNew();
	self.animalsUtil = animalsTable;
	self.loginEvent = noEventSend;
	return self;
end;

function AnimalsManagerEvent:writeStream(streamId, connection)
	streamWriteBool(streamId, self.loginEvent);
	if self.animalsUtil ~= nil then
		streamWriteString(streamId, tostring(self.animalsUtil));
	end;	
end;

function AnimalsManagerEvent:readStream(streamId, connection)
	self.loginEvent = streamReadBool(streamId);
	self.animalsUtil = streamReadString(streamId);
	self:run(connection);
end;

function AnimalsManagerEvent:run(connection)	
	if self.loginEvent then
		local animalsTableTemp = tostring(AnimalsManager.mpDetiServer.animalPlaceableLimit).. "-AM-".. tostring(AnimalsManager.mpDetiServer.animalVisualLimit).. "-AM-".. tostring(AnimalsManager.mpDetiServer.animalCleanLinessOff).. "-AM-".. tostring(AnimalsManager.mpDetiServer.animalCleanLinessOn).. "-AM-".. tostring(AnimalsManager.mpDetiServer.horseDeactivateRiding).. "-AM-".. tostring(AnimalsManager.mpDetiServer.horseDeactivateCare);
		AnimalsManagerEvent.sendEvent(animalsTableTemp, false);
	elseif not self.loginEvent then
		function setAnimalsToServer(streamString)
			local streamStringSplit = StringUtil.splitString("-AM-", streamString);
			if streamStringSplit ~= nil and #streamStringSplit > 0 then
				local placeableLimit = tonumber(streamStringSplit[1]);
				local visualLimit = tonumber(streamStringSplit[2]);
				local cleanLinessOff = tostring(streamStringSplit[3]);
				local cleanLinessOn = string.find(tostring(streamStringSplit[4]), "true");
				local horseDeactivateRiding = string.find(tostring(streamStringSplit[5]), "true");
				local horseDeactivateCare = string.find(tostring(streamStringSplit[6]), "true");
				AnimalHusbandry.GAME_LIMIT = placeableLimit;
				AnimalsManager.mpDetiServer.animalPlaceableLimit = placeableLimit;AnimalsManager.mpDetiServer.animalVisualLimit = visualLimit;AnimalsManager.mpDetiServer.animalCleanLinessOff = cleanLinessOff;AnimalsManager.mpDetiServer.animalCleanLinessOn = cleanLinessOn;AnimalsManager.mpDetiServer.horseDeactivateRiding = horseDeactivateRiding;AnimalsManager.mpDetiServer.horseDeactivateCare = horseDeactivateCare;
			end;		 
		end;
		if not AnimalsManager.isServerUpdate then
			setAnimalsToServer(self.animalsUtil);
			AnimalsManager:setCleanLiness();
			AnimalsManager:setVisual();
			--AnimalsManager:deactivateRiding();
			--AnimalsManager:deactivateCare();
			AnimalsManager.horseValues.dayRiding = not AnimalsManager.mpDetiServer.horseDeactivateRiding;
			AnimalsManager.horseValues.care = not AnimalsManager.mpDetiServer.horseDeactivateCare;
			AnimalsManager.isServerUpdate = true;
		end;
	end;
end;

function AnimalsManagerEvent.sendEvent(animalsTable, noEventSend)
	if g_server ~= nil and g_server ~= false and not noEventSend then		
		local animalsTableTemp = tostring(AnimalsManager.mpDetiServer.animalPlaceableLimit).. "-AM-".. tostring(AnimalsManager.mpDetiServer.animalVisualLimit).. "-AM-".. tostring(AnimalsManager.mpDetiServer.animalCleanLinessOff).. "-AM-".. tostring(AnimalsManager.mpDetiServer.animalCleanLinessOn).. "-AM-".. tostring(AnimalsManager.mpDetiServer.horseDeactivateRiding).. "-AM-".. tostring(AnimalsManager.mpDetiServer.horseDeactivateCare);
		g_server:broadcastEvent(AnimalsManagerEvent:new(animalsTableTemp, false), nil, nil, nil);		
	end;
	if g_server == nil and noEventSend then			
		g_client:getServerConnection():sendEvent(AnimalsManagerEvent:new(animalsTable, true));
	end;	
end;