AnimalsManagerVisualHud = {};

function AnimalsManagerVisualHud:loadHud()
	AnimalsManagerVisualHud.size = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize; --0.009;
	AnimalsManagerVisualHud.heightDistance = 0.004;
	AnimalsManagerVisualHud.widthDistance = 0.005;
	AnimalsManagerVisualHud.widthSeparatorDistance = 0.03;	
	AnimalsManagerVisualHud.globalTimer = 0;
	AnimalsManagerVisualHud.color = {
		prozent = {	{255/255, 	255/255, 	255/255,	1.00 }, --white
					{  0/255,	255/255, 	  0/255, 	1.00 }, --green
					{154/255, 	205/255,  	 50/255,	1.00 }, --yellowGreen
					{255/255, 	255/255, 	  0/255, 	1.00 }, --yellow
					{255/255, 	 65/255, 	  0/255, 	1.00 }, --orange
					{255/255,   28/255,   	  0/255, 	1.00 }, --orangeRed
					{255/255,	  0/255, 	  0/255, 	1.00 }  --red
		}	
	};
	if AnimalsManager.overlays == nil then AnimalsManager.overlays = {};end;
	local _,isOkay = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "groundAnimalVisual"}, "getSetDefaultBackground groundAnimalVisual");
	local _,isOkay1 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["groundAnimalVisual"], {0,0,0,0.7}}, "setBackgroundColor groundAnimalVisual");
	local _,isOkay2 = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "lineAnimalVisual"}, "getSetDefaultBackgroundLine lineAnimalVisual");
	local _,isOkay3 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {0,0,0,0.7}}, "setBackgroundLineColor lineAnimalVisual");
	local isOkayHorseHud = true;
	-------
	local isHorseHudByVehicleFruitHud = g_currentMission.vehicleFruitHud ~= nil and g_currentMission.vehicleFruitHud.visualFruitHorseHud ~= nil;
	if isHorseHudByVehicleFruitHud and AnimalsManager.visualHorseRidingHudTemp then g_currentMission.vehicleFruitHud.visualFruitHorseHud = false;end;
	if AnimalsManager.visualHorseRidingHudTemp then		
		AnimalsManager.horse = FillLevelsDisplay:new("dataS2/menu/hud/hud_elements_2160p.png");
		function getOptiWidthOverlay()	
			local width = g_currentMission.hud.fillLevelsDisplay.overlay.width;
			local horseDayRidingTxt = Utils.getNoNil(g_i18n:getText("ui_horseDailyRiding"), "Days Riding").. " ";
			local stringWidth = getTextWidth(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, horseDayRidingTxt.. " 100%");
			local i = 0;	
			while width < stringWidth do
				i = i + 0.05;			
				width = g_currentMission.hud.fillLevelsDisplay.overlay.width+i;
			end;		
			return width;
		end;
		local overlayWidth = getOptiWidthOverlay();
		local _,isOkay4 = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "groundLine"}, "getSetDefaultBackground groundLine");
		local _,isOkay5 = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "groundProzentLine"}, "getSetDefaultBackground groundProzentLine");
		local _,isOkay6 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["groundLine"], {131/255,139/255,139/255,0.50}}, "setBackgroundLineColor groundLine");
		local _,isOkay7 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["groundProzentLine"], {255/255,65/255,0/255,1.00}}, "setBackgroundColor groundProzentLine");
		local _,isOkay8 = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "groundFruitHorse"}, "getSetDefaultBackground groundFruitHorse");
		local _,isOkay9 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["groundFruitHorse"], {0,0,0,0.50}}, "setBackgroundColor groundFruitHorse");
		AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundLine"], 1.0-(overlayWidth*1.5),g_currentMission.hud.fillLevelsDisplay.origY,overlayWidth, 0.006}, "setOverlay BackgroundLine groundLine");
		AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundProzentLine"], 1.0-(overlayWidth*1.5),g_currentMission.hud.fillLevelsDisplay.origY,0, 0.006}, "setOverlay BackgroundLine groundProzentLine");
		isOkayHorseHud = isOkay4 and isOkay5 and isOkay6 and isOkay7 and isOkay8 and isOkay9;		
	end;
	
	
	AnimalsManagerVisualHud.loadOverlays = isOkay and isOkay1 and isOkay2 and isOkay3 and isOkayHorseHud;
	--AnimalsManagerVisualHud.isDrawVehicleName = false;	
end;

function AnimalsManagerVisualHud:update()
	local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode);	
	if px ~= nil and py ~= nil and pz ~= nil then --onFood Player
		local maxDistance = 6;
		local nearDistance = 0;
		local isVisible = false;
		for key, animalObject in pairs(AnimalsManager.indexToAnimals) do			
			if animalObject ~= nil and animalObject.modulesById ~= nil and animalObject.modulesById[1] ~= nil and animalObject.modulesById[1].animalLoadingTrigger ~= nil and animalObject.modulesById[1].animalLoadingTrigger.triggerNode ~= nil then				
				local ox,oy,oz = getWorldTranslation(animalObject.modulesById[1].animalLoadingTrigger.triggerNode)
				local distance = MathUtil.vector3Length(ox-px, oy-py, oz-pz);
				local distance1 = MathUtil.vector3Length(ox, oy, oz);
				if distance <= maxDistance then					
					nearDistance = distance;
					isVisible = true;					
					AnimalsManagerVisualHud:createHud(animalObject);
					if animalObject.visualHud ~= nil then animalObject.visualHud.isVisible = true;end;
					AnimalsManagerVisualHud:draw(animalObject, distance, distance1);
				else
					if animalObject.visualHud ~= nil then animalObject.visualHud.isVisible = false;end;
					if animalObject.visualHudFillTypesTicker ~= nil then
						for key, value in pairs(animalObject.visualHudFillTypesTicker) do
							value.isTimer = 0;value.isFillType=1;
						end;
					end;
				end;
			end;
		end;
	end;
end;

function AnimalsManagerVisualHud:draw(self, distance, distance1)
	if self ~= nil and self.visualHud ~= nil and self.visualHud.isVisible then
		--AnimalsManagerVisualHud.globalTimer = AnimalsManagerVisualHud.globalTimer+1;
		--respect settings for other mods
		setTextAlignment(0);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		--respect settings for other mods
		--renderText(0.6, 0.1, 0.010, "Near AnimalsManagerVisualHud..".. tostring(distance).. " - ".. tostring(distance1))
		local isOutput = false;
		local widthDistance = AnimalsManagerVisualHud.widthDistance;
		local heightDistance = AnimalsManagerVisualHud.heightDistance;
		local posX = 0.5-(self.visualHud.maxWidth/2);
		local posY = 0.02+self.visualHud.maxHeight;
		local size = AnimalsManagerVisualHud.size;
		if AnimalsManagerVisualHud.loadOverlays then
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundAnimalVisual"], posX,0.02-heightDistance,self.visualHud.maxWidth, self.visualHud.maxHeight+heightDistance}, "setOverlay Background AnimalsVisualHud");
			AnimalsManager.overlays["groundAnimalVisual"]:render();		
		end;
		setTextBold(true);
		renderText(posX, posY+(heightDistance/2), size+0.0005, tostring(g_i18n:getText("ui_husbandryInformation")));
		for key, output in pairs(self.visualHud.output) do			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtHeight = getTextHeight(size, tostring(output[1]))+heightDistance;			
			if output[3] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[output[3]]));end;
			renderText(posX+widthDistance, posY-txtHeight, size, tostring(output[1]));			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtWidth = getTextWidth(size, tostring(output[2]))+widthDistance;			
			if output[4] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[output[4]]));end;
			renderText(posX+self.visualHud.maxWidth-txtWidth, posY-txtHeight, size, tostring(output[2]));
			posY = posY-txtHeight;
			isOutput = true;
		end;
		if isOutput and AnimalsManagerVisualHud.loadOverlays then
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], posX+widthDistance,posY-(heightDistance/2),self.visualHud.maxWidth/2, heightDistance/4}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {1,1,1,0.7}}, "setBackgroundLineColor update lineAnimalVisual");
			AnimalsManager.overlays["lineAnimalVisual"]:render();
		end;
		for key, input in pairs(self.visualHud.input) do			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtHeight = getTextHeight(size, tostring(input[1]))+heightDistance;			
			if input[3] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[input[3]]));end;
			if self.visualHudFillTypesTicker ~= nil and self.visualHudFillTypesTicker[key] ~= nil then
				self.visualHudFillTypesTicker[key].isTimer = self.visualHudFillTypesTicker[key].isTimer+1;
				if self.visualHudFillTypesTicker[key].isTimer < 400 then
					renderText(posX+widthDistance, posY-txtHeight, size, tostring(input[1]))
				else
					local isTimer = 100*self.visualHudFillTypesTicker[key].isFillType;
					local maxTimer = 100*(#self.visualHudFillTypesTicker[key].fillTypes);					
					local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, self.visualHudFillTypesTicker[key].fillTypes[self.visualHudFillTypesTicker[key].isFillType]);
					local getFillTypeName = g_fillTypeManager.nameToFillType[fillTypeName].title;
					setTextBold(false);
					setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[4]));
					renderText(posX+widthDistance, posY-txtHeight, size, tostring(getFillTypeName));
					setTextBold(true);
					if self.visualHudFillTypesTicker[key].isTimer > 400+isTimer then self.visualHudFillTypesTicker[key].isFillType=self.visualHudFillTypesTicker[key].isFillType+1;end;
					if self.visualHudFillTypesTicker[key].isFillType > #self.visualHudFillTypesTicker[key].fillTypes then self.visualHudFillTypesTicker[key].isFillType=1;end;
					if self.visualHudFillTypesTicker[key].isTimer > 400+maxTimer then self.visualHudFillTypesTicker[key].isTimer=0;self.visualHudFillTypesTicker[key].isFillType=1;end;
				end;
			else
				AnimalsManagerVisualHud.globalTimer = 0;
				renderText(posX+widthDistance, posY-txtHeight, size, tostring(input[1]));
			end;			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtWidth = getTextWidth(size, tostring(input[2]))+widthDistance;			
			if input[4] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[input[4]]));end;
			renderText(posX+self.visualHud.maxWidth-txtWidth, posY-txtHeight, size, tostring(input[2]));
			posY = posY-txtHeight;
		end;
		if AnimalsManagerVisualHud.loadOverlays then
			AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {1,1,1,0.7}}, "setBackgroundLineColor update lineAnimalVisual");
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], AnimalsManager.overlays["groundAnimalVisual"].x+AnimalsManager.overlays["groundAnimalVisual"].width-(heightDistance/4),AnimalsManager.overlays["groundAnimalVisual"].y,heightDistance/4, self.visualHud.maxHeight+heightDistance}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager.overlays["lineAnimalVisual"]:render();
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], AnimalsManager.overlays["groundAnimalVisual"].x,AnimalsManager.overlays["groundAnimalVisual"].y+AnimalsManager.overlays["groundAnimalVisual"].height,self.visualHud.maxWidth, heightDistance/4}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager.overlays["lineAnimalVisual"]:render();		
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], posX,posY-(heightDistance*2),self.visualHud.maxWidth, heightDistance}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {255/255,65/255,0/255,0.7}}, "setBackgroundLineColor update lineAnimalVisual");
			AnimalsManager.overlays["lineAnimalVisual"]:render();		
		end;
		--respect settings for other mods
		setTextAlignment(0);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		--respect settings for other mods
	end;
end;

local onPrint=true;
function AnimalsManagerVisualHud:createHud(self)
	local animalModule = self:getModuleByName("animals");
	if animalModule ~= nil then		
		local animalName = tostring(animalModule:getAnimalType():lower());		
		self.visualHud = {output={}, input={}, isVisible=false, maxWidth=0, maxHeight=0};
		local animalNumber = "LARGE";
		if string.find(self.i3dFilename:lower(), "small") then animalNumber = "SMALL";end;
		table.insert(self.visualHud.output, {Utils.getNoNil(g_i18n:getText("animalPen_".. tostring((animalName))), "Name Unknown"), animalNumber, 0, 0, {}, {} });
		table.insert(self.visualHud.output, {g_i18n:getText("animal_stock"), Utils.getNoNil(animalModule:getNumOfAnimals(), 0), 0, 0, {}, {} });
		
		if animalName ~= "horse" and animalName ~= "dog" then
			if animalModule.reproductionRatesPerDay ~= nil then					
				local reproductionTimePerDay = 0;
				for fillType, rates in pairs(animalModule.reproductionRatesPerDay) do					
					if rates > 0 then
						reproductionTimePerDay = animalModule:getReproductionTimePerDay(fillType);
						break;							
					end;
				end;
				reproductionTimePerDay = g_i18n:formatMinutes(reproductionTimePerDay);
				table.insert(self.visualHud.output, {g_i18n:getText("statistic_reproductionRate"), tostring(reproductionTimePerDay), 0, 0, {}, {} });							
			end;
			if animalModule.newAnimalPercentages ~= nil then					
				--local newAnimalPercentages = 0;
				--local fillType = nil
				--for fillType, rates in pairs(animalModule.newAnimalPercentages) do					
				--	if rates > 0 then
				--		newAnimalPercentages = rates;fillType = fillType;
				--		break;							
				--	end;
				--end;
				--if newAnimalPercentages > 0 and fillType ~= nil then
				--	local reproductionDuration = 1.0 / newAnimalPercentages
				--	local reproMins = animalModule:getTimeUntilNextAnimal(fillType); --reproductionDuration * 24 * 60
				--	newAnimalPercentages = g_i18n:formatMinutes(reproMins);
				--	table.insert(self.visualHud.output, {g_i18n:getText("statistic_timeTillNextAnimal"), tostring(newAnimalPercentages), 0, 0, {}, {} });							
				--end;
			end;
			local prozentColor, isOkay = AnimalsManager:get_hl("getProzentColor", {Utils.getNoNil(self.globalProductionFactor, 0)*100, true}, "getProzentColor Productivity ".. tostring(animalName:upper()));
			if not isOkay then prozentColor = 0;end;
			table.insert(self.visualHud.output, {g_i18n:getText("statistic_productivity"), g_i18n:formatNumber(Utils.getNoNil(self.globalProductionFactor, 0)*100), 0, prozentColor, {}, {} });
			local foodSpillageModule = self:getModuleByName("foodSpillage");
			if foodSpillageModule ~= nil and foodSpillageModule.hasCleanliness then
				prozentColor, isOkay = AnimalsManager:get_hl("getProzentColor", {Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100, true}, "getProzentColor Dirt ".. tostring(animalName:upper()));
				if not isOkay then prozentColor = 0;end;
				table.insert(self.visualHud.output, {g_i18n:getText("statistic_cleanliness"), g_i18n:formatNumber(Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100), 0, prozentColor, {}, {} });
			else
				
			end;				
		end;
		local milkModule = self:getModuleByName("milk");
		if milkModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("statistic_milkStorage"), AnimalsManagerVisualHud:getFillTypeLevels(milkModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local liquidManureModule = self:getModuleByName("liquidManure");
		if liquidManureModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("statistic_liquidManureStorage"), AnimalsManagerVisualHud:getFillTypeLevels(liquidManureModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local manureModule = self:getModuleByName("manure");
		if manureModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("statistic_manureStorage"), AnimalsManagerVisualHud:getFillTypeLevels(manureModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local palletsModule = self:getModuleByName("pallets");
		if palletsModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("category_pallets"), AnimalsManagerVisualHud:getFillTypePal(palletsModule), 0, 0, {}, {} });end;
		
		local waterModule = self:getModuleByName("water");
		if waterModule ~= nil then table.insert(self.visualHud.input, {g_i18n:getText("statistic_water"), AnimalsManagerVisualHud:getFillTypeLevels(waterModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local strawModule = self:getModuleByName("straw");
		if strawModule ~= nil then table.insert(self.visualHud.input, {g_i18n:getText("statistic_strawStorage"), AnimalsManagerVisualHud:getFillTypeLevels(strawModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local foodModule = self:getModuleByName("food");
		if foodModule ~= nil then					
			local foodModuleTotal = foodModule:getFilltypeInfos();					
			if foodModuleTotal ~= nil and type(foodModuleTotal) == "table" and #foodModuleTotal > 0 then
				local isCapacity = false;
				for key, foodGroupTable in pairs(foodModuleTotal) do							
					if foodGroupTable ~= nil then
						if not isCapacity then 
							--table.insert(self.visualHud.output, 2, {g_i18n:getText("shop_capacity"), Utils.getNoNil(g_i18n:formatNumber(foodGroupTable.capacity), 0), 0, 0, {}, {} });
							table.insert(self.visualHud.output, 2, {g_i18n:getText("shop_capacity"), Utils.getNoNil(string.format("%1.0f", "".. foodGroupTable.capacity), 0), 0, 0, {}, {} });
							isCapacity = true;
						end;
						local fillLevelTotal = string.format("%1.0f", "".. foodGroupTable.fillLevel); --g_i18n:formatNumber(foodGroupTable.fillLevel);
						local fillTypesTotal = {};								
						if foodGroupTable.foodGroup ~= nil and foodGroupTable.foodGroup.fillTypes ~= nil then
							local foodGroupName = Utils.getNoNil(foodGroupTable.foodGroup.title, "Unknown");
							for _, fillType in pairs(foodGroupTable.foodGroup.fillTypes) do
								table.insert(fillTypesTotal, fillType);
							end;
							if #fillTypesTotal == 1 then 
								local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, fillTypesTotal[1]);
								foodGroupName = g_fillTypeManager.nameToFillType[fillTypeName].title;
							else
								if self.visualHudFillTypesTicker == nil then 
									self.visualHudFillTypesTicker = {};									
								end;
								if self.visualHudFillTypesTicker[#self.visualHud.input+1] == nil then self.visualHudFillTypesTicker[#self.visualHud.input+1] = {isTimer=0, isFillType=1};end;
							end;								
							table.insert(self.visualHud.input, {tostring(foodGroupName), fillLevelTotal, 0, 0, fillTypesTotal, {} });
							if self.visualHudFillTypesTicker ~= nil and self.visualHudFillTypesTicker[#self.visualHud.input] ~= nil then self.visualHudFillTypesTicker[#self.visualHud.input].fillTypes = fillTypesTotal;end;
						end;
					end;
				end;						
			end;					
		end;
		self.visualHud.maxWidth, self.visualHud.maxHeight = AnimalsManagerVisualHud:setAnimalsTxtWidthHeightTotal(self);		
	end;
end;

function updateModule(self, moduleName, isUpdateDefault, whatOutInput, pos, isColorUpdate)
	local isModule = self:getModuleByName(moduleName);
	if isModule ~= nil then
		if isUpdateDefault then
			self.visualHud[whatOutInput][pos][2] = AnimalsManagerVisualHud:getFillTypeLevels(isModule:getFilltypeInfos());
			local w1 = getTextWidth(AnimalsManagerVisualHud.size, tostring(self.visualHud[whatOutInput][pos][2]))+AnimalsManagerVisualHud.widthDistance;			
			if self.visualHud.maxWidth < w1 then self.visualHud.maxWidth = w1;end;
			return true;
		end;
		return isModule;
	end;
	return nil;
end;

function AnimalsManagerVisualHud:setAnimalsTxtWidthHeightTotal(self)
	local maxWidth = 0;
	local maxHeight = 0;
	local widthDistance = AnimalsManagerVisualHud.widthDistance;
	local heightDistance = AnimalsManagerVisualHud.heightDistance;
	local size = AnimalsManagerVisualHud.size;
	for whatTable, animalTable in pairs(self.visualHud.output) do
		local w1 = getTextWidth(size, tostring(animalTable[1]))+widthDistance;
		local w2 = getTextWidth(size, tostring(animalTable[2]))+widthDistance;
		local h1 = getTextHeight(size, tostring(animalTable[1]))+heightDistance;
		local h2 = getTextHeight(size, tostring(animalTable[2]))+heightDistance;
		if maxWidth < w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance then maxWidth = w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance;end;
		maxHeight = maxHeight+math.max(h1, h2);
	end;
	for whatTable, animalTable in pairs(self.visualHud.input) do
		local w1 = getTextWidth(size, tostring(animalTable[1]))+widthDistance;
		local w2 = getTextWidth(size, tostring(animalTable[2]))+widthDistance;
		local h1 = getTextHeight(size, tostring(animalTable[1]))+heightDistance;
		local h2 = getTextHeight(size, tostring(animalTable[2]))+heightDistance;
		if maxWidth < w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance then maxWidth = w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance;end;
		maxHeight = maxHeight+math.max(h1, h2);
	end;
	return maxWidth, maxHeight;
end;

function AnimalsManagerVisualHud:getFillTypePal(palletsModule)
	local maxDistance = 6;
	local palTotal = 0;	
	local x0,y0,z0 = getWorldTranslation(palletsModule.palletSpawnerNode);
	local result = getMapItems()
	if result ~= nil and palletsModule.palletFillTypeIndex ~= nil and result[palletsModule.palletFillTypeIndex] ~= nil then	
		for _, pal in pairs (result[palletsModule.palletFillTypeIndex]) do			
			if pal.x ~= nil and pal.y ~= nil and pal.z ~= nil then				
				local distance = MathUtil.vector3Length(pal.x-x0, pal.y-y0, pal.z-z0);
				if distance < maxDistance then palTotal = palTotal+1;end;
			end;
		end;
	end;	
	return palTotal;
end;

function getMapItems()
	local result = {};
	for key, value in pairs (g_currentMission.ownedItems) do
		if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
			for _, item in pairs(value.items) do				
				if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) then
					if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
						local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
						if item.spec_fillUnit.fillUnits[1].fillLevel == item.spec_fillUnit.fillUnits[1].capacity then
							local x0,y0,z0 = getWorldTranslation(item.rootNode);
							if result[fillType] == nil then result[fillType] = {};end;
							result[fillType][#result[fillType]+1] = {amount=1,fillLevel=item.spec_fillUnit.fillUnits[1].fillLevel,x=x0,y=y0,z=z0};							
						end;
					end;							
				end;
			end;
		end;
	end;
	return result;
end;

function AnimalsManagerVisualHud:getFillTypeLevels(fillTypeModule)
	local fillLevelsTotal = 0;
	local fillTypeIndex = 0;
	if fillTypeModule ~= nil and type(fillTypeModule) == "table" then
		for _, fillType in pairs(fillTypeModule) do
			fillLevelsTotal = fillLevelsTotal+fillType.fillLevel;
			fillTypeIndex = fillType.fillType;
		end;
	end;
	return string.format("%1.0f", "".. fillLevelsTotal); --g_i18n:formatNumber(fillLevelsTotal);
end;

-------------------------------------

function AnimalsManagerVisualHud:drawHorseHud()
	if not AnimalsManagerVisualHud.loadOverlays then return;end;
	local isControlled = g_currentMission.controlledVehicle;
	local foundHorse = false;
	local vehicle = nil;
	if isControlled then			
		vehicle = isControlled;
		if vehicle ~= nil and vehicle.getIsControlled ~= nil and vehicle.getIsControlled(vehicle) and g_gameSettings.nickname == vehicle.getControllerName(vehicle) then
			foundHorse = vehicle.specializationsByName ~= nil and vehicle.specializationsByName.rideable ~= nil and vehicle.spec_rideable ~= nil and vehicle.spec_rideable.animal ~= nil;
		end;
	end;
	if not foundHorse then return;end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	local frameHeight = g_currentMission.hud.fillLevelsDisplay.frameHeight;
	local size = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize;
	local txtHeight = getTextHeight(size, tostring("Gg"));
	local txtWidth = 0;
	local overlayWidth = AnimalsManager.overlays["groundLine"].width;
	local horseFitnessTxt = Utils.getNoNil(g_i18n:getText("ui_horseFitness"), "Fitness").. " ";
	local horseDayRidingTxt = Utils.getNoNil(g_i18n:getText("ui_horseDailyRiding"), "Days Riding").. " ";
	local horseTodayRidingTxt = "Today Riding  ";
	local horseCareTxt = Utils.getNoNil(g_i18n:getText("statistic_cleanliness"), "Care").. " ";
	local horseHealthTxt = "Health";
	local posX = 1.0-(overlayWidth*1.5);
	local posY = g_currentMission.hud.fillLevelsDisplay.origY;	
	
	if not AnimalsManager.horseValues.care then
		AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundFruitHorse"], posX-(overlayWidth*0.1),posY-(txtHeight*1.1),overlayWidth*1.2, posY+(txtHeight*17)}, "setOverlay Background drawHud groundFruitHorse");
	else
		AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundFruitHorse"], posX-(overlayWidth*0.1),posY-(txtHeight*0.5),overlayWidth*1.2, posY+(txtHeight*16.5)}, "setOverlay Background drawHud groundFruitHorse");
	end;
	AnimalsManager.overlays["groundFruitHorse"]:render();
	
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local careScale = g_i18n:formatNumber(100-(Utils.getNoNil(Horse.getDirtScale(vehicle.spec_rideable.animal), 0)*100));
	setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[2]));	
	renderText(posX, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseCareTxt));
	if not AnimalsManager.horseValues.care then
		setTextColor(0,1,1,1);
		renderText(posX, posY-(txtHeight), size-0.0015, tostring("(Disabled)"));
	end;
	txtWidth = getTextWidth(size, tostring(careScale).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+AnimalsManager.overlays["groundLine"].width-txtWidth, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(careScale).. "%");
	if tonumber(careScale) > 100 then careScale = 100;end;
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundProzentLine"], posX,posY,overlayWidth/100*careScale, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	AnimalsManager.overlays["groundLine"]:render();
	AnimalsManager.overlays["groundProzentLine"]:render();
		
	posY = posY+(txtHeight*4);
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local healthScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal), 0)*100);
	setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[2]));
	renderText(posX, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseHealthTxt));
	txtWidth = getTextWidth(size, tostring(healthScale).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+AnimalsManager.overlays["groundLine"].width-txtWidth, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(healthScale).. "%");
	if tonumber(healthScale) > 100 then healthScale = 100;end;
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundProzentLine"], posX,posY,overlayWidth/100*healthScale, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	AnimalsManager.overlays["groundLine"]:render();
	AnimalsManager.overlays["groundProzentLine"]:render();	
	
	posY = posY+(txtHeight*4);
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local fitnessScale = g_i18n:formatNumber(Utils.getNoNil(Horse.getFitnessScale(vehicle.spec_rideable.animal), 0)*100);
	setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[2]));
	renderText(posX, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseFitnessTxt));
	txtWidth = getTextWidth(size, tostring(fitnessScale).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+AnimalsManager.overlays["groundLine"].width-txtWidth, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(fitnessScale).. "%");
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundProzentLine"], posX,posY,overlayWidth/100*fitnessScale, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	AnimalsManager.overlays["groundLine"]:render();
	AnimalsManager.overlays["groundProzentLine"]:render();		
	
	posY = posY+(txtHeight*4);
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local dayRidingTime = g_i18n:formatNumber(Utils.getNoNil(vehicle.spec_rideable.animal.ridingScale, 0)*100);	
	setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[2]));
	renderText(posX, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseDayRidingTxt));
	txtWidth = getTextWidth(size, tostring(dayRidingTime).. "%");
	setTextColor(1,1,1,1);
	renderText(posX+AnimalsManager.overlays["groundLine"].width-txtWidth, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(dayRidingTime).. "%");
	if not AnimalsManager.horseValues.dayRiding then
		setTextColor(0,1,1,1);
		renderText(posX, posY-(txtHeight), size-0.0015, tostring("(Disabled)"));
	end;	
	if tonumber(dayRidingTime) > 100 then dayRidingTime = 100;end;
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundProzentLine"], posX,posY,overlayWidth/100*dayRidingTime, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	AnimalsManager.overlays["groundLine"]:render();
	AnimalsManager.overlays["groundProzentLine"]:render();	
	
	posY = posY+(txtHeight*3);
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundLine"], posX,posY,nil, nil}, "setOverlay BackgroundLine drawHud groundLine");
	local todaysRidingTime = Utils.getNoNil(Horse.getTodaysRidingTime(vehicle.spec_rideable.animal), 0);
	local nHours = string.format("%02.f", math.floor(todaysRidingTime/3600000));
	local nMins = string.format("%02.f", math.floor(todaysRidingTime/60000 - (nHours*60)));
	local todaysRidingTimeTemp = g_i18n:formatMinutes(tonumber(nMins));
	setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[2]));
	renderText(posX, posY+AnimalsManager.overlays["groundLine"].height, size, tostring(horseTodayRidingTxt));	
	AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundProzentLine"], posX,posY,overlayWidth/2, nil}, "setOverlay BackgroundLine drawHud groundProzentLine");
	txtWidth = getTextWidth(size, tostring(todaysRidingTimeTemp));
	setTextColor(1,1,1,1);
	renderText(posX+AnimalsManager.overlays["groundLine"].width-txtWidth, posY+AnimalsManager.overlays["groundLine"].height, size, tostring(todaysRidingTimeTemp));
	
	posY = posY+(txtHeight*1);	
	--horseValue = g_i18n:formatMoney((0.99 * (Utils.getNoNil(Horse.getFitnessScale(vehicle.spec_rideable.animal), 0)*Utils.getNoNil(Horse.getHealthScale(vehicle.spec_rideable.animal), 0)*Utils.getNoNil(Horse.getDirtScale(vehicle.spec_rideable.animal), 0)) + 0.01 * (1-Utils.getNoNil(Horse.getDirtScale(vehicle.spec_rideable.animal), 0)))*100000/2);
	horseValue = g_i18n:formatMoney(Utils.getNoNil(Horse.getValueScale(vehicle.spec_rideable.animal, 0))*100000/2);
	txtWidth = getTextWidth(size, tostring(horseValue));
	setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[3]));
	renderText(posX+AnimalsManager.overlays["groundLine"].width-txtWidth, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size, tostring(horseValue));
	
	setTextColor(1,1,1,1);
	posY = posY+(txtHeight*1.5);
	local horseName = tostring(vehicle.getName(vehicle):upper());
	renderText(posX, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight*0.5), size+0.003, tostring(horseName));
	local speed = AnimalsManagerVisualHud:getSpeed(vehicle);
	local speedTxt = tostring(g_i18n:getText("unit_kmh"));
	if g_gameSettings:getValue('useMiles') then speedTxt = tostring(g_i18n:getText("unit_miles"));end;
	txtWidth = getTextWidth(size, tostring(speed).. " ".. tostring(speedTxt));
	if tonumber(speed) > 0 then
		setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[4]));
		posY = posY+(txtHeight*1.2);
		--AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundFruitHorse"], posX-(overlayWidth*0.1),g_currentMission.hud.fillLevelsDisplay.origY-(txtHeight*0.5),overlayWidth*1.2, g_currentMission.hud.fillLevelsDisplay.origY+(txtHeight*18.5)}, "setOverlay Background drawHud groundFruitHorse");
		renderText(posX, posY+AnimalsManager.overlays["groundLine"].height+(txtHeight), size+0.002, tostring(speed).. " ".. tostring(speedTxt));
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;

function AnimalsManagerVisualHud:getSpeed(vehicle)
	local speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3600;
	if g_gameSettings:getValue('useMiles') then speed = speed*0.621371;end;
	return string.format("%1.0f", "".. Utils.getNoNil(speed, 0));
end;

